///////////////////////////////////////////////////////////////////////////////
// tgApp
//
//
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __TGAPP_H__
#define __TGAPP_H__

///////////////////////////////////////////////////////////////////////////////
// Class definition
///////////////////////////////////////////////////////////////////////////////

#include "tgImgPlugin.h"
#include "tgOutputPlugin.h"
#include "tgPluginsList.h"

class tgApp
{
	///////////////////////////////////////////////////////////////////////////
	public:
	///////
	tgApp(const char *plugins_path);
	~tgApp();

	int LoadPlugins(char* argv);

	int IsImgLoadingSupported(char *ext);
	int IsOutputSupported(char *id);

	int GetPictureInfo(const char* pFileName,tgPictureInfo* pInfo);
	int GetPictureData(uint8* Data,tgColor* Palette);

	tgOutputPlugin* GetOutputWriter(void);
	
	///////////////////////////////////////////////////////////////////////////
	protected:
	//////////
	char m_PluginsPath[256];
	tgPluginsList<tgImgPlugin> *m_ImgPlugins;
	tgPluginsList<tgOutputPlugin> *m_OutputPlugins;

	tgImgPlugin		*m_ImgLoader;
	tgOutputPlugin	*m_OutputWriter;

	///////////////////////////////////////////////////////////////////////////
	private:
	////////

};

///////////////////////////////////////////////////////////////////////////////

#endif