///////////////////////////////////////////////////////////////////////////////
// tgPlugin
//
//
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __TGPLUGIN_H__
#define __TGPLUGIN_H__

///////////////////////////////////////////////////////////////////////////////
// Class definition
///////////////////////////////////////////////////////////////////////////////

#include "windows.h"

class tgPlugin
{
	///////////////////////////////////////////////////////////////////////////
	public:
	///////

	tgPlugin(const char* filename);
	~tgPlugin();

	char* GetDescription(void);
	char* GetAuthor(void);
	char* GetVersion(void);
	char* GetFileName(void);
	char* GetContactInfo(void);

	///////////////////////////////////////////////////////////////////////////
	protected:
	//////////

	typedef	char* (*fctGetDescription)(void);
	typedef	char* (*fctGetAuthor)(void);
	typedef	char* (*fctGetVersion)(void);
	typedef char* (*fctGetContactInfo)(void);

	char	m_FileName[256];
	HINSTANCE		m_Library;	
	fctGetDescription	m_fctGetDescription;
	fctGetAuthor		m_fctGetAuthor;
	fctGetVersion		m_fctGetVersion;
	fctGetContactInfo	m_fctGetContactInfo;

	void GetSymbols(void);

	///////////////////////////////////////////////////////////////////////////
	private:
	////////
		
};

///////////////////////////////////////////////////////////////////////////////

#endif